### Hierarchy

- <internal>.WebSocket
  - WebSocketAlias

## Index

### Properties

- CLOSED
- CLOSING
- CONNECTING
- OPEN
- binaryType
- bufferedAmount
- extensions
- isPaused
- onclose
- onerror
- onmessage
- onopen
- protocol
- readyState
- url

### Methods

- addEventListener
- addListener
- close
- emit
- eventNames
- getMaxListeners
- listenerCount
- listeners
- off
- on
- once
- pause
- ping
- pong
- prependListener
- prependOnceListener
- rawListeners
- removeAllListeners
- removeEventListener
- removeListener
- resume
- send
- setMaxListeners
- terminate

## Properties

### Readonly CLOSED

CLOSED: 3

Inherited from WebSocket.CLOSED

The connection is closed.

### Readonly CLOSING

CLOSING: 2

Inherited from WebSocket.CLOSING

The connection is in the process of closing.

### Readonly CONNECTING

CONNECTING: 0

Inherited from WebSocket.CONNECTING

The connection is not yet open.

### Readonly OPEN

OPEN: 1

Inherited from WebSocket.OPEN

The connection is open and ready to communicate.

### binaryType

binaryType: "nodebuffer" | "arraybuffer" | "fragments"

Inherited from WebSocket.binaryType

### Readonly bufferedAmount

bufferedAmount: number

Inherited from WebSocket.bufferedAmount

### Readonly extensions

extensions: string

Inherited from WebSocket.extensions

### Readonly isPaused

isPaused: boolean

Inherited from WebSocket.isPaused

Indicates whether the websocket is paused

### onclose

onclose: (event: <internal>.CloseEvent) => void

Inherited from WebSocket.onclose

#### Type declaration

- - (event: <internal>.CloseEvent): void

  - #### Parameters

    - ##### event: <internal>.CloseEvent

    #### Returns void

### onerror

onerror: (event: <internal>.ErrorEvent) => void

Inherited from WebSocket.onerror

#### Type declaration

- - (event: <internal>.ErrorEvent): void

  - #### Parameters

    - ##### event: <internal>.ErrorEvent

    #### Returns void

### onmessage

onmessage: (event: <internal>.MessageEvent) => void

Inherited from WebSocket.onmessage

#### Type declaration

- - (event: <internal>.MessageEvent): void

  - #### Parameters

    - ##### event: <internal>.MessageEvent

    #### Returns void

### onopen

onopen: (event: <internal>.Event) => void

Inherited from WebSocket.onopen

#### Type declaration

- - (event: <internal>.Event): void

  - #### Parameters

    - ##### event: <internal>.Event

    #### Returns void

### Readonly protocol

protocol: string

Inherited from WebSocket.protocol

### Readonly readyState

readyState: 0 | 2 | 1 | 3

Inherited from WebSocket.readyState

The current state of the connection

### Readonly url

url: string

Inherited from WebSocket.url

## Methods

### addEventListener

- addEventListener(method: "message", cb: (event: <internal>.MessageEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "close", cb: (event: <internal>.CloseEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "error", cb: (event: <internal>.ErrorEvent) => void, options?: <internal>.EventListenerOptions): void
- addEventListener(method: "open", cb: (event: <internal>.Event) => void, options?: <internal>.EventListenerOptions): void

- Inherited from WebSocket.addEventListener

  #### Parameters

  - ##### method: "message"

  - ##### cb: (event: <internal>.MessageEvent) => void

    - - (event: <internal>.MessageEvent): void

      - #### Parameters

        - ##### event: <internal>.MessageEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocket.addEventListener

  #### Parameters

  - ##### method: "close"

  - ##### cb: (event: <internal>.CloseEvent) => void

    - - (event: <internal>.CloseEvent): void

      - #### Parameters

        - ##### event: <internal>.CloseEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocket.addEventListener

  #### Parameters

  - ##### method: "error"

  - ##### cb: (event: <internal>.ErrorEvent) => void

    - - (event: <internal>.ErrorEvent): void

      - #### Parameters

        - ##### event: <internal>.ErrorEvent

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

- Inherited from WebSocket.addEventListener

  #### Parameters

  - ##### method: "open"

  - ##### cb: (event: <internal>.Event) => void

    - - (event: <internal>.Event): void

      - #### Parameters

        - ##### event: <internal>.Event

        #### Returns void

  - ##### Optional options: <internal>.EventListenerOptions

  #### Returns void

### addListener

- addListener(event: "close", listener: (code: number, reason: <internal>.Buffer) => void): <internal>.WebSocketAlias
- addListener(event: "error", listener: (err: <internal>.Error) => void): <internal>.WebSocketAlias
- addListener(event: "upgrade", listener: (request: IncomingMessage) => void): <internal>.WebSocketAlias
- addListener(event: "message", listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocketAlias
- addListener(event: "open", listener: () => void): <internal>.WebSocketAlias
- addListener(event: "ping" | "pong", listener: (data: <internal>.Buffer) => void): <internal>.WebSocketAlias
- addListener(event: "unexpected-response", listener: (request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocketAlias
- addListener(event: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  Alias for `emitter.on(eventName, listener)`.

  #### Parameters

  - ##### event: "close"

  - ##### listener: (code: number, reason: <internal>.Buffer) => void

    - - (code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (request: IncomingMessage) => void

    - - (request: IncomingMessage): void

      - #### Parameters

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "message"

  - ##### listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "open"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (data: <internal>.Buffer) => void

    - - (data: <internal>.Buffer): void

      - #### Parameters

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (request: ClientRequest, response: IncomingMessage) => void

    - - (request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.addListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### close

- close(code?: number, data?: string | <internal>.Buffer): void

- Inherited from WebSocket.close

  #### Parameters

  - ##### Optional code: number

  - ##### Optional data: string | <internal>.Buffer

  #### Returns void

### emit

- emit(eventName: string | symbol, ...args: any[]): boolean

- Inherited from WebSocket.emit

  Synchronously calls each of the listeners registered for the event named`eventName`, in the order they were registered, passing the supplied arguments to each.

  Returns `true` if the event had listeners, `false` otherwise.

      const EventEmitter = require('events');
      const myEmitter = new EventEmitter();

      // First listener
      myEmitter.on('event', function firstListener() {
        console.log('Helloooo! first listener');
      });
      // Second listener
      myEmitter.on('event', function secondListener(arg1, arg2) {
        console.log(`event with parameters ${arg1}, ${arg2} in second listener`);
      });
      // Third listener
      myEmitter.on('event', function thirdListener(...args) {
        const parameters = args.join(', ');
        console.log(`event with parameters ${parameters} in third listener`);
      });

      console.log(myEmitter.listeners('event'));

      myEmitter.emit('event', 1, 2, 3, 4, 5);

      // Prints:
      // [
      //   [Function: firstListener],
      //   [Function: secondListener],
      //   [Function: thirdListener]
      // ]
      // Helloooo! first listener
      // event with parameters 1, 2 in second listener
      // event with parameters 1, 2, 3, 4, 5 in third listener

  since

    v0.1.26

  #### Parameters

  - ##### eventName: string | symbol

  - ##### Rest ...args: any[]

  #### Returns boolean

### eventNames

- eventNames(): (string | symbol)[]

- Inherited from WebSocket.eventNames

  Returns an array listing the events for which the emitter has registered listeners. The values in the array are strings or `Symbol`s.

      const EventEmitter = require('events');
      const myEE = new EventEmitter();
      myEE.on('foo', () => {});
      myEE.on('bar', () => {});

      const sym = Symbol('symbol');
      myEE.on(sym, () => {});

      console.log(myEE.eventNames());
      // Prints: [ 'foo', 'bar', Symbol(symbol) ]

  since

    v6.0.0

  #### Returns (string | symbol)[]

### getMaxListeners

- getMaxListeners(): number

- Inherited from WebSocket.getMaxListeners

  Returns the current max listener value for the `EventEmitter` which is either set by `emitter.setMaxListeners(n)` or defaults to defaultMaxListeners.

  since

    v1.0.0

  #### Returns number

### listenerCount

- listenerCount(eventName: string | symbol): number

- Inherited from WebSocket.listenerCount

  Returns the number of listeners listening to the event named `eventName`.

  since

    v3.2.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event being listened for

  #### Returns number

### listeners

- listeners(eventName: string | symbol): Function[]

- Inherited from WebSocket.listeners

  Returns a copy of the array of listeners for the event named `eventName`.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });
      console.log(util.inspect(server.listeners('connection')));
      // Prints: [ [Function] ]

  since

    v0.1.26

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### off

- off(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocketAlias
- off(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocketAlias
- off(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocketAlias
- off(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocketAlias
- off(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocketAlias
- off(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocketAlias
- off(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocketAlias
- off(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.off

  Alias for `emitter.removeListener()`.

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.off

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### on

- on(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocketAlias
- on(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocketAlias
- on(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocketAlias
- on(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocketAlias
- on(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocketAlias
- on(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocketAlias
- on(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocketAlias
- on(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.on

  Adds the `listener` function to the end of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      const myEE = new EventEmitter();
      myEE.on('foo', () => console.log('a'));
      myEE.prependListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.on

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### once

- once(event: "close", listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void): <internal>.WebSocketAlias
- once(event: "error", listener: (this: <internal>.WebSocket, err: <internal>.Error) => void): <internal>.WebSocketAlias
- once(event: "upgrade", listener: (this: <internal>.WebSocket, request: IncomingMessage) => void): <internal>.WebSocketAlias
- once(event: "message", listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocketAlias
- once(event: "open", listener: (this: <internal>.WebSocket) => void): <internal>.WebSocketAlias
- once(event: "ping" | "pong", listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void): <internal>.WebSocketAlias
- once(event: "unexpected-response", listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocketAlias
- once(event: string | symbol, listener: (this: <internal>.WebSocket, ...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.once

  Adds a one-time `listener` function for the event named `eventName`. The next time `eventName` is triggered, this listener is removed and then invoked.

      server.once('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependOnceListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      const myEE = new EventEmitter();
      myEE.once('foo', () => console.log('a'));
      myEE.prependOnceListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: "close"

  - ##### listener: (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "error"

  - ##### listener: (this: <internal>.WebSocket, err: <internal>.Error) => void

    - - (this: <internal>.WebSocket, err: <internal>.Error): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (this: <internal>.WebSocket, request: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "message"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (this: <internal>.WebSocket, data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "open"

  - ##### listener: (this: <internal>.WebSocket) => void

    - - (this: <internal>.WebSocket): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (this: <internal>.WebSocket, data: <internal>.Buffer) => void

    - - (this: <internal>.WebSocket, data: <internal>.Buffer): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage) => void

    - - (this: <internal>.WebSocket, request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.once

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (this: <internal>.WebSocket, ...args: any[]) => void

    - - (this: <internal>.WebSocket, ...args: any[]): void

      - #### Parameters

        - ##### this: <internal>.WebSocket

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### pause

- pause(): void

- Inherited from WebSocket.pause

  Pause the websocket causing it to stop emitting events. Some events can still be emitted after this is called, until all buffered data is consumed. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

### ping

- ping(data?: any, mask?: boolean, cb?: (err: <internal>.Error) => void): void

- Inherited from WebSocket.ping

  #### Parameters

  - ##### Optional data: any

  - ##### Optional mask: boolean

  - ##### Optional cb: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

### pong

- pong(data?: any, mask?: boolean, cb?: (err: <internal>.Error) => void): void

- Inherited from WebSocket.pong

  #### Parameters

  - ##### Optional data: any

  - ##### Optional mask: boolean

  - ##### Optional cb: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

### prependListener

- prependListener(eventName: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.prependListener

  Adds the `listener` function to the beginning of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.prependListener('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v6.0.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event.

  - ##### listener: (...args: any[]) => void

    The callback function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### prependOnceListener

- prependOnceListener(eventName: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.prependOnceListener

  Adds a one-time `listener` function for the event named `eventName` to the_beginning_ of the listeners array. The next time `eventName` is triggered, this listener is removed, and then invoked.

      server.prependOnceListener('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v6.0.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event.

  - ##### listener: (...args: any[]) => void

    The callback function

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### rawListeners

- rawListeners(eventName: string | symbol): Function[]

- Inherited from WebSocket.rawListeners

  Returns a copy of the array of listeners for the event named `eventName`, including any wrappers (such as those created by `.once()`).

      const emitter = new EventEmitter();
      emitter.once('log', () => console.log('log once'));

      // Returns a new Array with a function `onceWrapper` which has a property
      // `listener` which contains the original listener bound above
      const listeners = emitter.rawListeners('log');
      const logFnWrapper = listeners[0];

      // Logs "log once" to the console and does not unbind the `once` event
      logFnWrapper.listener();

      // Logs "log once" to the console and removes the listener
      logFnWrapper();

      emitter.on('log', () => console.log('log persistently'));
      // Will return a new Array with a single function bound by `.on()` above
      const newListeners = emitter.rawListeners('log');

      // Logs "log persistently" twice
      newListeners[0]();
      emitter.emit('log');

  since

    v9.4.0

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### removeAllListeners

- removeAllListeners(event?: string | symbol): <internal>.WebSocketAlias

- Inherited from WebSocket.removeAllListeners

  Removes all listeners, or those of the specified `eventName`.

  It is bad practice to remove listeners added elsewhere in the code, particularly when the `EventEmitter` instance was created by some other component or module (e.g. sockets or file streams).

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.1.26

  #### Parameters

  - ##### Optional event: string | symbol

  #### Returns <internal>.WebSocketAlias

### removeEventListener

- removeEventListener(method: "message", cb: (event: <internal>.MessageEvent) => void): void
- removeEventListener(method: "close", cb: (event: <internal>.CloseEvent) => void): void
- removeEventListener(method: "error", cb: (event: <internal>.ErrorEvent) => void): void
- removeEventListener(method: "open", cb: (event: <internal>.Event) => void): void

- Inherited from WebSocket.removeEventListener

  #### Parameters

  - ##### method: "message"

  - ##### cb: (event: <internal>.MessageEvent) => void

    - - (event: <internal>.MessageEvent): void

      - #### Parameters

        - ##### event: <internal>.MessageEvent

        #### Returns void

- Inherited from WebSocket.removeEventListener

  #### Parameters

  - ##### method: "close"

  - ##### cb: (event: <internal>.CloseEvent) => void

    - - (event: <internal>.CloseEvent): void

      - #### Parameters

        - ##### event: <internal>.CloseEvent

        #### Returns void

- Inherited from WebSocket.removeEventListener

  #### Parameters

  - ##### method: "error"

  - ##### cb: (event: <internal>.ErrorEvent) => void

    - - (event: <internal>.ErrorEvent): void

      - #### Parameters

        - ##### event: <internal>.ErrorEvent

        #### Returns void

- Inherited from WebSocket.removeEventListener

  #### Parameters

  - ##### method: "open"

  - ##### cb: (event: <internal>.Event) => void

    - - (event: <internal>.Event): void

      - #### Parameters

        - ##### event: <internal>.Event

        #### Returns void

### removeListener

- removeListener(event: "close", listener: (code: number, reason: <internal>.Buffer) => void): <internal>.WebSocketAlias
- removeListener(event: "error", listener: (err: <internal>.Error) => void): <internal>.WebSocketAlias
- removeListener(event: "upgrade", listener: (request: IncomingMessage) => void): <internal>.WebSocketAlias
- removeListener(event: "message", listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void): <internal>.WebSocketAlias
- removeListener(event: "open", listener: () => void): <internal>.WebSocketAlias
- removeListener(event: "ping" | "pong", listener: (data: <internal>.Buffer) => void): <internal>.WebSocketAlias
- removeListener(event: "unexpected-response", listener: (request: ClientRequest, response: IncomingMessage) => void): <internal>.WebSocketAlias
- removeListener(event: string | symbol, listener: (...args: any[]) => void): <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  Removes the specified `listener` from the listener array for the event named`eventName`.

      const callback = (stream) => {
        console.log('someone connected!');
      };
      server.on('connection', callback);
      // ...
      server.removeListener('connection', callback);

  `removeListener()` will remove, at most, one instance of a listener from the listener array. If any single listener has been added multiple times to the listener array for the specified `eventName`, then `removeListener()` must be called multiple times to remove each instance.

  Once an event is emitted, all listeners attached to it at the time of emitting are called in order. This implies that any`removeListener()` or `removeAllListeners()` calls after emitting and_before_ the last listener finishes execution will not remove them from`emit()` in progress. Subsequent events behave as expected.

      const myEmitter = new MyEmitter();

      const callbackA = () => {
        console.log('A');
        myEmitter.removeListener('event', callbackB);
      };

      const callbackB = () => {
        console.log('B');
      };

      myEmitter.on('event', callbackA);

      myEmitter.on('event', callbackB);

      // callbackA removes listener callbackB but it will still be called.
      // Internal listener array at time of emit [callbackA, callbackB]
      myEmitter.emit('event');
      // Prints:
      //   A
      //   B

      // callbackB is now removed.
      // Internal listener array [callbackA]
      myEmitter.emit('event');
      // Prints:
      //   A

  Because listeners are managed using an internal array, calling this will change the position indices of any listener registered after the listener being removed. This will not impact the order in which listeners are called, but it means that any copies of the listener array as returned by the `emitter.listeners()` method will need to be recreated.

  When a single function has been added as a handler multiple times for a single event (as in the example below), `removeListener()` will remove the most recently added instance. In the example the `once('ping')`listener is removed:

      const ee = new EventEmitter();

      function pong() {
        console.log('pong');
      }

      ee.on('ping', pong);
      ee.once('ping', pong);
      ee.removeListener('ping', pong);

      ee.emit('ping');
      ee.emit('ping');

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: "close"

  - ##### listener: (code: number, reason: <internal>.Buffer) => void

    - - (code: number, reason: <internal>.Buffer): void

      - #### Parameters

        - ##### code: number

        - ##### reason: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (request: IncomingMessage) => void

    - - (request: IncomingMessage): void

      - #### Parameters

        - ##### request: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "message"

  - ##### listener: (data: <internal>.WebSocket.RawData, isBinary: boolean) => void

    - - (data: <internal>.WebSocket.RawData, isBinary: boolean): void

      - #### Parameters

        - ##### data: <internal>.WebSocket.RawData

        - ##### isBinary: boolean

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "open"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "ping" | "pong"

  - ##### listener: (data: <internal>.Buffer) => void

    - - (data: <internal>.Buffer): void

      - #### Parameters

        - ##### data: <internal>.Buffer

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: "unexpected-response"

  - ##### listener: (request: ClientRequest, response: IncomingMessage) => void

    - - (request: ClientRequest, response: IncomingMessage): void

      - #### Parameters

        - ##### request: ClientRequest

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns <internal>.WebSocketAlias

- Inherited from WebSocket.removeListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns <internal>.WebSocketAlias

### resume

- resume(): void

- Inherited from WebSocket.resume

  Make a paused socket resume emitting events. This method is a noop if the ready state is `CONNECTING` or `CLOSED`.

  #### Returns void

### send

- send(data: any, cb?: (err?: <internal>.Error) => void): void
- send(data: any, options: { binary?: boolean; compress?: boolean; fin?: boolean; mask?: boolean }, cb?: (err?: <internal>.Error) => void): void

- Inherited from WebSocket.send

  #### Parameters

  - ##### data: any

  - ##### Optional cb: (err?: <internal>.Error) => void

    - - (err?: <internal>.Error): void

      - #### Parameters

        - ##### Optional err: <internal>.Error

        #### Returns void

- Inherited from WebSocket.send

  #### Parameters

  - ##### data: any

  - ##### options: { binary?: boolean; compress?: boolean; fin?: boolean; mask?: boolean }

    - ##### Optional binary?: boolean

    - ##### Optional compress?: boolean

    - ##### Optional fin?: boolean

    - ##### Optional mask?: boolean

  - ##### Optional cb: (err?: <internal>.Error) => void

    - - (err?: <internal>.Error): void

      - #### Parameters

        - ##### Optional err: <internal>.Error

        #### Returns void

### setMaxListeners

- setMaxListeners(n: number): <internal>.WebSocketAlias

- Inherited from WebSocket.setMaxListeners

  By default `EventEmitter`s will print a warning if more than `10` listeners are added for a particular event. This is a useful default that helps finding memory leaks. The `emitter.setMaxListeners()` method allows the limit to be modified for this specific `EventEmitter` instance. The value can be set to`Infinity` (or `0`) to indicate an unlimited number of listeners.

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.3.5

  #### Parameters

  - ##### n: number

  #### Returns <internal>.WebSocketAlias

### terminate

- terminate(): void

- Inherited from WebSocket.terminate

  #### Returns void

Generated using TypeDoc